
#define IRQ32MOD	0x12
#define SVC32MOD	0x13
#define SYS32MOD	0x1f
#define NOINT		0xc0

.global _start

_start:

exception_vector_table:	
	b	stack_setup
	ldr	pc, vectorUndefined
	ldr	pc, vectorSWI
	ldr	pc, vectorPrefetchAbort
	ldr	pc, vectorDataAbort
	ldr	pc, vectorReserved
	ldr	pc, vectorIRQ
	ldr	pc, vectorFIQ
exception_vector_table_end:		
		
stack_setup:
	bl	_led_off			@ 커널로 잘 진입했음을 확인
	
	ldr	r0, =_start
	sub	r0, r0, #4
	mov	sp, r0				@ SVC stack :	0x300ffffc

	msr	cpsr_c, #NOINT|IRQ32MOD
	sub	sp, r0, #0x6000			@ IRQ stack :	0x300f9ffc

	msr	cpsr_c, #NOINT|SVC32MOD
	
	ldr	pc, =kmain

		
vectorUndefined:
	.word do_undefined

vectorSWI:
	.word do_software_interrupt

vectorPrefetchAbort:
	.word do_prefetch_abort

vectorDataAbort:
	.word do_data_abort

vectorReserved:
	.word do_reserved

vectorIRQ:	
	.word do_IRQ
	
vectorFIQ:	
	.word do_FIQ