
#ifndef _TCB_H
#define _TCB_H

#include "system.h"

#define TASK_BASE	 0x30500000
#define TASK_STACK_BASE	 0x30600000
#define TASK_ADDR_OFFSET 0x100000

#define MIN_PRIOR		10	/* 가장 낮은 우선순위		*/
#define MAX_PRIOR		0	/* 가장 높은 우선순위		*/

#define MAX_TASK_COUNT		6	/* 동시 수행가능한 최대 태스크수	*/

typedef struct _task_struct
{
    unsigned int rR[13];		/* 태스크의 context 정보		*/
    unsigned int rSP;
    unsigned int rLR;
    unsigned int rCPSR;
    unsigned int rPC;
    
    unsigned char task_name[20];	/* 태스크명				*/
    unsigned int pid;			/* 태스크 아이디			*/
    unsigned int prior;			/* 태스크의 우선순위			*/
    unsigned int time_remain;		/* 타임 슬라이스를 배정받고 남은 갯수	*/
    unsigned int time_slice;		/* 타임 슬라이스를 배정받을 갯수		*/
    unsigned int need_resched;		/* 스케줄링을 할 필요가 있을때 사용	*/
} tcb;


void task_init();
int task_enroll(char task_name[20], unsigned int prior, unsigned int slice);
int run_task(unsigned int pid);

#endif
