
#include "tcb.h"
#include "timer.h"
#include "printk.h"
#include "schedule.h"
#include "interrupt.h"
#include "system.h"

extern tcb *current;

void do_irq_timer0();

void eventsIRQHandler()
{
    unsigned int INTOPND;
    unsigned int INTOFFSET;
    
    INTOPND = rINTPND;
    INTOFFSET = rINTOFFSET;

    rSRCPND |= INTOPND;
    rINTPND |= INTOPND;

    switch (INTOFFSET) {

    case 0xa:			/* timer0 */
	do_irq_timer0();
	break;
	
    default:

    }

    /*
     * 스케줄링을 수행한다
     */
    if (current->need_resched == 1) {
	current->need_resched = 0;
	schedule();
    }
}

void do_irq_timer0()
{
    static unsigned int jiffes = 0;

    jiffes++;

    current->time_remain--;
    if (current->time_remain <= 0) {
	current->time_remain = current->time_slice;
	current->need_resched = 1;
    }
}
