
#include "tcb.h"
#include "timer.h"
#include "system.h"
#include "printk.h"
#include "syscall.h"
#include "interrupt.h"

void kmain(void)
{
    load_irq_disable();
    load_fiq_disable();

    uart_init();		/* UART0 초기화				*/
    printk("UART0 init.....................[OK]\n");

    interrupt_init();		/* 모든 인터럽트 mask, 초기화		*/
    printk("INTERRUPT init.................[OK]\n");
    
    task_init();		/* task들을 관리하는 TCB 초기화		*/
    printk("TASK init......................[OK]\n");

    task_enroll("LED-checker" , 90, 2); /* 2번째 태스크를 등록한다		*/
    printk("TASK1 enroll...................[OK]\n");
    
    task_enroll("SYSCALL_test", 89, 2); /* 3번째 태스크를 등록한다		*/
    printk("TASK2 enroll...................[OK]\n");
    
    timer_init();		/* 타이머0 초기화				*/
    printk("TIMER0 init....................[OK]\n");

    printk("theBlueOS have booted..........[OK]\n\n");

    printk("run IDLE Task..................[OK]\n");

    if (run_task(0)) {		/* runt task0 (idle task)			*/
	printk("idle task run failed!\n");
	while (1)
	    ;
    }

    while(1)			/* 정상이라면 이곳으로 오지 않는다.		*/
	;
}
