
#include "uart.h"

/*
 * 시스템 콜
 *
 * include/syscall.h에 시스템 콜들이 포장되어 있다.
 */
void SWI_000();			/* syscall_test()	*/
void SWI_001();			/* print_systime()	*/


/*
 * Software Interrupt Handler
 */
void eventsSWIHandler(unsigned int syscallnum)
{
    switch(syscallnum) {

    case 0:
	SWI_000();
	break;
	
    case 1:
	SWI_001();
	break;
	
    default:
	uart_puts("SWI bad number\n");
	uart_puthexnl(syscallnum);
    }
}

/*
 * SWI 000: SWI test message
 */
void SWI_000()
{
    uart_puts("syscall number 0\n");
}

/*
 * SWI 001: RTC를 이용한 현재 실제 일자/시간을 uart0로 출력한다.
 */
void SWI_001()
{
    uart_puts("syscall number 1\n");
}
