
#include "tcb.h"
#include "system.h"
#include "string.h"

/*
 * ù° ½ũ(idle)  ϴµ,
 *  ° ̿ؼ  ̻ ½ũ ġ Ϸ Ѵ.
 */
tcb *current = NULL;
tcb task_struct[MAX_TASK_COUNT];

unsigned int task_count       = 0;
unsigned int task_current_pid = 0;		/* Ŀ  0 pid */

/*
 * ٸ  TCB ʱȭ idle ½ũ Ѵ
 *
 * :  Լ Ŀο  ȣؾ ϴ Լ̸,
 *        task_enroll ռ ȣǾ Ѵ.
 */
void task_init()
{
    task_count = 0;		/* űϴ. ⼭ ʱȭ  
				 * Ʈ ½    ִ. ׷
				 * ʱȭ  ʿߴ.*/
    
    task_enroll("IDLE", MAX_PRIOR, 1);

    task_current_pid = 0;
    current = &task_struct[0];
}


/*
 * ½ũ Ҽ ְ Ѵ.
 *
 * :  Լ task_init  pid 0 idle ½ũ ڵ ϵȴ.
 *
 * : task_name: ½ũ ̸, prior: 켱, slice: Ҵ tick
 *
 * ϰ: : 0, : 1
 */
int task_enroll(char task_name[20], unsigned int prior, unsigned int slice)
{
    int i;
    int pid;
    
    task_count++;
    if (task_count > MAX_TASK_COUNT)		/* ½ũ  ʰ 		*/
	return 1;

    pid  = task_count - 1;
    
    load_task(pid);				/* NOR RAM ½ũ ̹
						 * Ѵ. */

    strcpy(task_struct[pid].task_name, task_name);
    
    task_struct[pid].pid   = pid;
    task_struct[pid].prior = prior;
    task_struct[pid].time_slice   = slice;
    task_struct[pid].time_remain  = slice;
    task_struct[pid].need_resched = 0;

    for (i=0; i<12; i++)
	task_struct[pid].rR[i] = 0;

    task_struct[pid].rPC = TASK_BASE       + (pid * TASK_ADDR_OFFSET);
    task_struct[pid].rSP = TASK_STACK_BASE + (pid * TASK_ADDR_OFFSET) - 4;

    task_struct[pid].rCPSR = 0x50;		/* ̰, ͷƮ 
						 * (80 = 0x50)	*/
    return 0;
}


/*
 * pid شϴ ½ũ 忡 Ѵ.
 *   Լ  ؼ pid شϴ ½ũ ̵ϸ鼭
 * ٷ ͷƮ Ų
 *
 * :  Լ task_initԼ ȣ ,
 *       ½ũ  غ  ̾ Ѵ.
 *
 *      
 * ڰ: unsigned int pid: Ϸ ½ũ pid (task_struct ÷ڰ)
 * 
 * ϰ: =0, =1
 */
int run_task(unsigned int pid)
{
    unsigned int temp = 0;
    unsigned int task_addr;
    unsigned int task_sp_addr;

    if ((task_addr = task_struct[pid].rPC)    <= 0 ||
	(task_sp_addr = task_struct[pid].rSP) <= 0)
	return 1;

    __asm__ __volatile__ (
	"mrs	%0, cpsr\n"		\
	"bic	%0, %0, #0xff\n"	\
	"orr	%0, %0, #0x50\n"	\
	"msr	cpsr, %0\n"		\
	"mov	sp, %2\n"		\
	"mov	pc, %1\n"		\
	:"=r"(temp)			\
	:"r"(task_addr), "r"(task_sp_addr)	\
	:"memory", "cc");

    return 0;
}
