
#include "timer.h"
#include "interrupt.h"
#include "printk.h"

void timer_init()
{
    rGPBCON &= ~0x3;		/* GPB TOUT0 	*/
    rGPBCON |= 0x2;
    rGPBUP |= 0x1;

    rTCFG0 &= ~0xff;
    rTCFG0 |= 0xf;		/* prescaler = 15	*/
    rTCFG1 &= ~0xf;
    rTCFG1 = 0x2;		/* divider   = 2	*/

    
    /*
     * Ʒ ּ  2.4.x Ŀμҽ Ϻκ̴
     *  κ ߴ
     *
     * LINUX_KERNEL_ROOT/include/asm/arch/time.h
     *
     * priod = (prescaler value + 1) * (divider value) * buffer count / PCLK = 10 ms
     *
     * e.g.; PCLK = 50 Mhz
     * 10 ms = (15 + 1) * 2 * 15625 / (50000 * 1000)
     * 15626 = 10 ms * (50000 * 1000) / 2 / (15 + 1)
     *
     * Other values
     *  5156 = 10 ms * ( 16.5 * 1,000,000) / 2 / (15+1)
     *  6250 = 10 ms * ( 20 * 1,000,000) / 2 / (15+1)
     * 10312 = 10 ms * ( 33 * 1,000,000) / 2 / (15+1)
     * 20625 = 10 ms * ( 66 * 1,000,000) / 2 / (15+1)
     * 21875 = 10 ms * ( 70 * 1,000,000) / 2 / (15+1)
     * 23437 = 10 ms * ( 75 * 1,000,000) / 2 / (15+1)
     * 25000 = 10 ms * ( 80 * 1,000,000) / 2 / (15+1)
     * 28125 = 10 ms * ( 90 * 1,000,000) / 2 / (15+1)
     * 31250 = 10 ms * ( 100 * 1,000,000) / 2 / (15+1)
     */
    
    rTCON &= ~(0xff);

    rTCNTB0 = 10 * (PCLK) / 2 / (15+1) / 1000;
    rTCMPB0 = rTCNTB0 / 2;

    rTCON |= 0x2;		/* timer0 manual update */
    
    rINTMSK &= ~(1<<10);	/* timer0 interrupt use */
    rSRCPND |= 1<<10;
    rINTPND |= 1<<10;

    rTCON &= ~0xff;    
    rTCON |= 0x9;		/* timer0 count start, auto reload */
}
